# enable_gtkdoc: Toggle if gtkdoc stuff should be rebuilt
#	0 = no
#	1 = yes
%define enable_gtkdoc	0

# Note that this is NOT a relocatable package
%define api_version	2.0
%define lib_major	0
%define lib_name	%mklibname %{name}_ %{lib_major}
%define libgio_name	%mklibname gio%{api_version}_ %{lib_major}
%define develname	%mklibname -d %name
%define staticname	%mklibname -d -s %name

%define url_ver %(echo %{version}|cut -d. -f1,2)

Summary:	A library of handy utility functions
Name:		glib%{api_version}
Version:	2.50.1
Release:	%mkrel 1
License:	LGPLv2+
Group:		System/Libraries
Source0:	https://download.gnome.org/sources/glib/%{url_ver}/glib-%{version}.tar.xz
Source1:	glib20.sh
Source2:	glib20.csh
Patch0:		glib-silence-deprecated-paths.patch
Patch1:		glib-2.38.0-GIO-xfce4-terminal-support.patch
Patch2:		0001-Bug-730332-glib-uses-wrong-timezone-transition-with-.patch
Patch3:		0002-Bug-730332-Guard-against-reading-past-the-end-of-a-t.patch
URL:		http://www.gtk.org
#-----------------------------------------
Requires:	common-licenses
Requires:	shared-mime-info
BuildRequires:	dbus-devel
BuildRequires:	gettext
BuildRequires:	libtool
BuildRequires:	locales-en
BuildRequires:	xsltproc
BuildRequires:	docbook-xsl
BuildRequires:	docbook-style-xsl
BuildRequires:	libxml2-utils
BuildRequires: %{_lib}elfutils-devel
BuildRequires: %{_lib}ffi-devel
BuildRequires: %{_lib}pcre0-devel
#-----------------------------------------

%if %enable_gtkdoc
BuildRequires:	gtk-doc >= 0.10
%endif

#gw this was required since 2.23.2 (new atomic OPs?)
%define _requires_exceptions GLIBC_PRIVATE

%description
Glib is a handy library of utility functions. This C
library is designed to solve some portability problems
and provide other useful functionality which most
programs require.

Glib is used by GDK, GTK+ and many applications.

%package common
Summary:	data files used by glib
Group:		System/Libraries

%description common
Glib is a handy library of utility functions. This C
library is designed to solve some portability problems
and provide other useful functionality which most
programs require.

This package contains data used by glib library.

%package -n %{lib_name}
Summary:	%{summary}
Group:		System/Libraries
Provides:	glib2 = %{version}-%{release}
Provides:	libglib2 = %{version}-%{release}
Provides:	lib%{name} = %{version}-%{release}

%description -n %{lib_name}
Glib is a handy library of utility functions. This C
library is designed to solve some portability problems
and provide other useful functionality which most
programs require.

Glib is used by GDK, GTK+ and many applications.
You should install Glib because many of your applications
will depend on this library.

This package contains the library needed to run programs dynamically
linked with the glib.

%package -n %{libgio_name}
Summary:	GIO is the input, output and streaming API of glib
Group:		System/Libraries
Requires:	%{lib_name} = %{version}
Requires(post):	%{lib_name} = %{version}

%description -n %{libgio_name}
GIO is the input, output and streaming API of glib. It on the one hand
provides a set of various streaming classes to access data from different
sources in a convenient way and on the other hand it provides a high level
file system abstraction to access file and directories not only local but also
on the network. For the latter you need to install gvfs.


%package -n %develname
Summary:	Static libraries and header files of %{name}
Group:		Development/Libraries
Provides:	glib2-devel = %{version}-%{release}
Provides:	libglib2-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Obsoletes:	%{_lib}glib2.0_0-devel < %version
Obsoletes:	%{_lib}glib2.0_0-devel+
Provides:	%{_lib}glib2.0_0-devel = %version-%release
#------------------------------------------------
Requires:	%{lib_name} = %{version}
Requires:	%{libgio_name} = %{version}
Requires:	%{name}-common = %{version}
Requires:	glib-gettextize >= %{version}
#------------------------------------------------

%description -n %develname
Header files for the support library for the GIMP's X libraries, which are
available as public libraries. GLIB includes generally useful data structures.

%package -n %staticname
Summary:	Static libraries and header files of %{name}
Group:		Development/Libraries
Requires:	%develname = %{version}-%{release}
Provides:	glib2-static-devel = %{version}-%{release}
Provides:	libglib2-static-devel = %{version}-%{release}
Provides:	lib%{name}-static-devel = %{version}-%{release}

%description -n %staticname
Static libraries and files for the support library for the GIMP's X libraries,
which are available as public libraries. GLIB includes generally useful data
structures.

%package -n glib-gettextize
Summary:	Gettextize replacement
Group:		System/Libraries

%description -n glib-gettextize
%{name} package is designed to replace gettextize completely.
Various gettext related files are modified in glib and gtk+ to
allow better and more flexible i18n; however gettextize overwrites
them with its own copy of files, thus nullifying the changes.
If this replacement of gettextize is run instead, then all gnome
packages can potentially benefict from the changes.

%prep
%setup -n glib-%{version} -q
%apply_patches


%build

autoreconf -vfi
%configure2_5x \
	--with-pcre=system \
	--enable-static \
	--disable-selinux \
	--disable-fam \
	--disable-systemtap \
%if !%enable_gtkdoc
	--enable-gtk-doc=no
%endif

%make


%install
rm -rf %buildroot

%makeinstall_std

mkdir -p %buildroot/%{_sysconfdir}/profile.d
install -m 644 %{SOURCE1} %buildroot/%{_sysconfdir}/profile.d/50glib20.sh
install -m 644 %{SOURCE2} %buildroot/%{_sysconfdir}/profile.d/50glib20.csh

%find_lang glib20

mv %buildroot%{_bindir}/gio-querymodules %buildroot%{_bindir}/gio-querymodules-%{__isa_bits}

#ghost files
touch %buildroot/%{_libdir}/gio/modules/giomodule.cache \
      %buildroot/%{_datadir}/glib-2.0/schemas/gschemas.compiled


install -d %buildroot%{_var}/lib/rpm/filetriggers 
cat > %buildroot%{_var}/lib/rpm/filetriggers/glib-compile-schemas.filter << EOF
^.%{_datadir}/glib-2.0/schemas/[^/]*\.xml$
^.%{_datadir}/glib-2.0/schemas/[^/]*\.override$
EOF

cat > %buildroot%{_var}/lib/rpm/filetriggers/glib-compile-schemas.script << EOF
#!/bin/sh
if [ -x /usr/bin/glib-compile-schemas ]; then
  /usr/bin/glib-compile-schemas --allow-any-name %{_datadir}/glib-2.0/schemas/
fi
EOF

chmod 755 %buildroot%{_var}/lib/rpm/filetriggers/glib-compile-schemas.script 

# automatic update of gio module cache
cat > %buildroot/%{_var}/lib/rpm/filetriggers/gio-querymodules.filter << EOF
^.%{_libdir}/gio/modules/*.so$
EOF

cat > %buildroot/%{_var}/lib/rpm/filetriggers/gio-querymodules.script <<EOF
#!/bin/sh
%{_bindir}/gio-querymodules-%{__isa_bits} %{_libdir}/gio/modules	 
EOF


# don't ship .a files for gio modules
rm -f %buildroot/%{_libdir}/gio/modules/lib*a

# we don't want these
find %{buildroot} -name "*.la" -delete
rm -f %buildroot/%{_datadir}/glib-2.0/gdb/*.{pyc,pyo}


%post -n %{lib_name}
/sbin/ldconfig

%postun -n %{lib_name}
/sbin/ldconfig

%post -n %{libgio_name}
%if %_lib != lib
 %{_bindir}/gio-querymodules-64 %{_libdir}/gio/modules 
%else
 %{_bindir}/gio-querymodules-32 %{_libdir}/gio/modules
%endif


%files common -f glib20.lang
%defattr(-,root,root)
%doc README
%config(noreplace) %{_sysconfdir}/profile.d/*
%{_datadir}/bash-completion/completions/gapplication
%{_datadir}/bash-completion/completions/gdbus
%{_datadir}/bash-completion/completions/gsettings
%{_datadir}/bash-completion/completions/gresource
%{_bindir}/gapplication
%{_bindir}/gdbus
%{_bindir}/gresource
%{_bindir}/glib-compile-schemas
%{_bindir}/glib-compile-resources
%{_bindir}/gsettings
%{_mandir}/man1/gio-querymodules.1*
%{_mandir}/man1/glib-compile-schemas.1*
%{_mandir}/man1/glib-compile-resources.1*
%{_mandir}/man1/gsettings.1*
%{_mandir}/man1/gapplication.1*
%{_mandir}/man1/gdbus.1*
%{_mandir}/man1/gresource.1*
%dir %{_datadir}/glib-2.0/
%dir %{_datadir}/glib-2.0/schemas/
%{_datadir}/glib-2.0/schemas/gschema.dtd
%ghost %{_datadir}/glib-2.0/schemas/gschemas.compiled
%{_var}/lib/rpm/filetriggers/glib-compile-schemas.*
%{_var}/lib/rpm/filetriggers/gio-querymodules.*
%{_datadir}/gettext/its/
%{_bindir}/gio
%{_datadir}/man/man1/gio.1.bz2


%files -n %{lib_name}
%defattr(-,root,root)
%{_libdir}/libglib-%{api_version}.so.*
%{_libdir}/libgmodule-%{api_version}.so.*
%{_libdir}/libgthread-%{api_version}.so.*
%{_libdir}/libgobject-%{api_version}.so.*

%files -n %{libgio_name}
%{_bindir}/gio-querymodules-*
%{_libdir}/libgio-%{api_version}.so.*
%dir %{_libdir}/gio/
%dir %{_libdir}/gio/modules/
%ghost %{_libdir}/gio/modules/giomodule.cache
%ghost %{_datadir}/glib-2.0/schemas/gschemas.compiled

%files -n %develname
%defattr(-,root,root)
%doc AUTHORS NEWS
%doc %{_datadir}/gtk-doc/html/*
%{_libdir}/lib*.so
%{_libdir}/glib-%{api_version}
%{_datadir}/glib-%{api_version}/codegen
%{_libdir}/pkgconfig/*
%{_includedir}/*
%{_mandir}/man1/glib-genmarshal.1*
%{_mandir}/man1/glib-mkenums.1*
%{_mandir}/man1/gobject-query.1*
%{_mandir}/man1/gtester-report.1*
%{_mandir}/man1/gtester.1*
%{_mandir}/man1/gdbus-codegen.1*
%{_datadir}/aclocal/glib-%{api_version}.m4
%{_datadir}/aclocal/gsettings.m4
%{_bindir}/glib-genmarshal
%{_bindir}/glib-mkenums
%{_bindir}/gobject-query
%{_bindir}/gtester*
%{_bindir}/gdbus-codegen
%{_datadir}/gdb/auto-load%{_libdir}/lib*-gdb.py*
%{_datadir}/glib-%{api_version}/gdb

%files -n glib-gettextize
%defattr(-,root,root)
%{_bindir}/glib-gettextize
%{_mandir}/man1/glib-gettextize.1*
%{_datadir}/aclocal/glib-gettext.m4
%{_datadir}/glib-%{api_version}/gettext

%files -n %staticname
%defattr(-,root,root)
%{_libdir}/lib*.a

%clean
rm -rf %buildroot


%changelog
* Thu Nov 03 2016 adrianomorselli <adrianomorselli> 2.50.1-1uplos2016
- rebuild

* Tue Oct 11 2016 bb <bb> 2.50.1-1pclos2016
- update

* Fri Jul 22 2016 bb <bb> 2.48.1-2pclos2016
- rebuild new libffi

* Sat May 14 2016 bb <bb> 2.48.1-1pclos2016
- update

* Wed Apr 27 2016 bb <bb> 2.48.0-1pclos2016
- update

* Sat Nov 07 2015 bb <bb> 2.46.2-1pclos2015
- update

* Wed Oct 14 2015 bb <bb> 2.46.1-1pclos2015
- update
